<?php
class WBBridgeBridge {
   static function main() {
   	  global $wpdb;
   	  
   	  // select exams
   	  $exams = $wpdb->get_results("SELECT * FROM ".WATUPRO_EXAMS." ORDER BY name");
   	  
   	  // select mailing lists
   	  $lists = $wpdb->get_results("SELECT * FROM ".BFTPRO_LISTS." ORDER BY name");
   	  
   	  // add/edit/delete relation
   	  if(!empty($_POST['add'])) {
				// no duplicates		
				$exists = $wpdb->get_var($wpdb->prepare("SELECT id FROM ".WBBRIDGE_RELATIONS."
					WHERE exam_id=%d AND list_id=%d AND grade_id=%d", $_POST['exam_id'], $_POST['list_id'], $_POST['grade_id']));   	  	
   	  	
   	  	if(!$exists) {
					$wpdb->query($wpdb->prepare("INSERT INTO ".WBBRIDGE_RELATIONS." SET 
						exam_id = %d, list_id=%d, grade_id=%d", $_POST['exam_id'], $_POST['list_id'], $_POST['grade_id']));
					}   	  
   	  }
   
   		if(!empty($_POST['save'])) {
				$wpdb->query($wpdb->prepare("UPDATE ".WBBRIDGE_RELATIONS." SET 
					exam_id = %d, list_id=%d, grade_id=%d WHERE id=%d", 
					$_POST['exam_id'], $_POST['list_id'], $_POST['grade_id'], $_POST['id']));   	  
   	  }
   	  
			if(!empty($_POST['del'])) {
				$wpdb->query($wpdb->prepare("DELETE FROM ".WBBRIDGE_RELATIONS." WHERE id=%d", $_POST['id']));
			}   	  
   	  
   	  // select existing relations
   	  $relations = $wpdb->get_results("SELECT * FROM ".WBBRIDGE_RELATIONS." ORDER BY id");
   	  
   	  // select all non-category grades and match them to exams and relations
   	  $grades = $wpdb->get_results("SELECT * FROM ".WATUPRO_GRADES." WHERE cat_id=0 ORDER BY gtitle");
   	  
   	  foreach($exams as $cnt=>$exam) {
   	  	  $exam_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $exam->ID) $exam_grades[] = $grade;
			  }
			  
			  $exams[$cnt]->grades = $exam_grades;
   	  }
   	  
   	  foreach($relations as $cnt=>$relation) {
   	  	  $rel_grades = array();
   	  	  foreach($grades as $grade) {
   	  	  	if($grade->exam_id == $relation->exam_id) $rel_grades[] = $grade;
			  }
			  
			  $relations[$cnt]->grades = $rel_grades;
   	  }
   	  
   	  include(WBBRIDGE_PATH."/views/main.html.php");
   }

	 // actually subscribe the user
	 static function complete_exam($taking_id) {
	 	  global $wpdb;
	 	  include_once(BFTPRO_PATH."/models/user.php");
	 	  
	 	  // select taking		
	 	  $taking = $wpdb->get_row($wpdb->prepare("SELECT * FROM ".WATUPRO_TAKEN_EXAMS." 	
	 	  	WHERE ID=%d", $taking_id));
	 	  	
	 	  // if email not available, return false
			if(empty($taking->user_id) and empty($taking->email)) return false;
			
	 	  // see if there are any relations for this exam ID
	 	  $relations = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".WBBRIDGE_RELATIONS." 
		 	  WHERE exam_id=%d", $taking->exam_id));
		 	  
		 	if(!count($relations)) return false;  
		 	  
		// define email and name
	   $email = $taking->email;
		$name = $taking->name;
		if(empty($email)) {
			$user = get_userdata($taking->user_id);
      	$email = $user->user_email;
      	$name = $user->display_name;
		}
      
         $_bftpro_user = new BFTProUser();
		 	$message = '';  
		 	foreach($relations as $relation) {
				// check grade
				if(!empty($relation->grade_id) and $relation->grade_id != $taking->grade_id) continue;
				
				$vars = array("name"=>$name, "email"=>$email, "list_id"=>$relation->list_id);
				// fill any required fields with "1" to avoid errors			
				$fields=$wpdb->get_results($wpdb->prepare("SELECT * FROM ".BFTPRO_FIELDS." WHERE list_id=%d", $relation->list_id));
				foreach($fields as $field) {
					if(!$field->is_required) continue;
					$vars['field_'.$field->id] = empty($data['field_'.$field->id]) ? 1 : $data['field_'.$field->id];
				}		 		
		 		
		 		$_bftpro_user->subscribe($vars, $message, true);
			}
   } // end complete exam
}